﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace nGSO
{
    public class IterationProgressEventArgs : EventArgs
    {
        public int Percentage { get; private set; }
        public int CurrentStep { get; private set; }
        public int MaxIterations { get; private set; }
        public IEnumerable<Agent> LastIterationHistory { get;private set; }

        public IterationProgressEventArgs(int currentStep, int maxIterations, IEnumerable<Agent> lastHistory)
        {
            CurrentStep = currentStep;
            MaxIterations = maxIterations;

            Percentage = currentStep / maxIterations * 100;
            LastIterationHistory = lastHistory;
        }
    }
}
