﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.IO;

namespace nGSO
{
    public class Program
    {
        public static void Main(string[] args)
        {
            Stopwatch sw = Stopwatch.StartNew();

            //SetDebugToFile();

            IGsoEngine engine = new GsoEngine(new GsoConfig());
            var result = engine.StartGSOSolving();

            sw.Stop();
            Debug.Flush();
            Environment.Exit(0);
        }

        private static void SetDebugToFile()
        {
            FileStream debugFile = File.Create("debug.txt");
            TextWriterTraceListener myTextListener = new TextWriterTraceListener(debugFile);
            Debug.Listeners.Add(myTextListener);
            Trace.Listeners.Add(new ConsoleTraceListener());

            Console.WriteLine("Debug file created " + debugFile.Name);
        }
    }
}